; ------------------------------------------
; Title: OpenGL test
; 
; Author: Franck "hitchhikr" Charlet.
;
; Notes: Just a little example on how to use OpenGL.
;	 Needs OpenGl32.dll and Glu32.dll (should be no problem).
;
; ------------------------------------------

; --------------- Assembler directives
			.386
      			.model	flat,stdcall
			option	casemap:none  

; --------------- External includes
			include	\masm32\include\windows.inc
			include \masm32\include\user32.inc
			include \masm32\include\kernel32.inc
			include \masm32\include\gdi32.inc
			include \masm32\include\opengl32.inc
			include \masm32\include\glu32.inc

			includelib \masm32\lib\user32.lib
			includelib \masm32\lib\kernel32.lib
			includelib \masm32\lib\gdi32.lib
			includelib \masm32\lib\opengl32.lib
			includelib \masm32\lib\glu32.lib

; --------------- These constants are not defined in windows.inc
PFD_MAIN_PLANE		equ	0
PFD_TYPE_COLORINDEX	equ	1
PFD_TYPE_RGBA		equ	0
PFD_DOUBLEBUFFER	equ	1
PFD_DRAW_TO_WINDOW	equ	4
PFD_SUPPORT_OPENGL	equ	020h

IPicture 		STRUCT
; IUnknown methods
QueryInterface          DWORD   ?
AddRef                  DWORD   ?
Release                 DWORD   ?
; IPicture methods
get_Handle              DWORD   ?
get_hPal                DWORD   ?
get_Type                DWORD   ?
get_Width               DWORD   ?
get_Height              DWORD   ?
Render                  DWORD   ?	
set_hPal                DWORD   ?
get_CurDC               DWORD   ?
SelectPicture           DWORD   ?
get_KeepOriginalFormat  DWORD   ?
put_KeepOriginalFormat  DWORD   ?
PictureChanged          DWORD   ?
SaveAsFile              DWORD   ?
get_Attributes          DWORD   ?
IPicture		ENDS

; --------------- Data Section
			.data
szDisplayName		db	"TestOpenGL - Written by Franck 'hitchhikr' Charlet.",0
szClassName		db	"TestOpenGL_Class",0
szTextureName		db	"masm32.tga",0			; Texture filename

PixFrm			PIXELFORMATDESCRIPTOR <>

hWnd			dd	0
MainHDC			dd	0
OpenDC			dd	0
hInstance		dd	0
hTexture		dd	0

; Some values
Value0Flt		dd	0.0
Value1Flt		dd	1.0
Value1Dbl		dq	1.0
Value45Dbl		dq	45.0
Value3Dbl		dq	3.0
Value7Dbl		dq	7.0

; Light position
LightSourcePosition	dd	-2.0,-2.0,-4.0,0.0
LightSource2Position	dd	2.0,2.0,4.0,0.0
LightSource3Position	dd	-2.0,2.0,4.0,0.0
LightAmbient		dd	0.2,0.0,0.0,1.0
Light2Ambient		dd	0.0,0.2,0.0,1.0
Light3Ambient		dd	0.0,0.0,0.2,1.0
LightDiffuse		dd	1.0,1.0,1.0,1.0
LightSpecular		dd	1.0,1.0,1.0,1.0
SpotCut			dd	-1.0
SpotExp			dd	0.0
SpotDir			dd	-1.0,-1.0,-1.0
LightConstAtt		dd	1.0
LightLinAtt		dd	1.0
LightQuadAtt		dd	1.0

; --- Sphere 1
; Angles
Sphere1AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere1AnglesSpeedFlt	dd	-1.0,-1.2,-1.4
; Objects datas
Sphere1Color		dd	0.6,0.4,0.2,0.5
Sphere1Radius		dq	1.0
sphere1Parts		dd	24
Sphere1Position		dd	0.0,0.0,-5.0
GlSphere1		dd	0

; --- Sphere 2
; Angles
Sphere2AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere2AnglesSpeedFlt	dd	-1.0,0.8,-0.4
; Objects datas
Sphere2Color		dd	0.4,0.6,0.2,0.5
Sphere2Radius		dq	0.3
sphere2Parts		dd	16
Sphere2Position		dd	0.0,0.0,-1.5
GlSphere2		dd	0

; --- Sphere 3
; Angles
Sphere3AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere3AnglesSpeedFlt	dd	-1.0,-0.8,1.4
; Objects datas
Sphere3Color		dd	0.2,0.4,0.6,0.5
Sphere3Radius		dq	0.3
sphere3Parts		dd	16
Sphere3Position		dd	0.0,0.0,1.5
GlSphere3		dd	0

; --- Sphere 4
; Angles
Sphere4AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere4AnglesSpeedFlt	dd	-1.0,1.4,-0.8
; Objects datas
Sphere4Color		dd	0.4,0.2,0.6,0.5
Sphere4Radius		dq	0.3
sphere4Parts		dd	16
Sphere4Position		dd	0.0,1.5,0.0
GlSphere4		dd	0

; --- Sphere 5
; Angles
Sphere5AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere5AnglesSpeedFlt	dd	1.0,1.8,0.8
; Objects datas
Sphere5Color		dd	0.6,0.2,0.4,0.5
Sphere5Radius		dq	0.3
sphere5Parts		dd	16
Sphere5Position		dd	1.5,0.0,0.0
GlSphere5		dd	0

; --- Sphere 6
; Angles
Sphere6AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere6AnglesSpeedFlt	dd	1.0,-1.8,2.0
; Objects datas
Sphere6Color		dd	0.2,0.6,0.4,0.5
Sphere6Radius		dq	0.3
sphere6Parts		dd	16
Sphere6Position		dd	-1.5,0.0,0.0
GlSphere6		dd	0

; --- Sphere 7
; Angles
Sphere7AnglesFlt	dd	0.0,0.0,0.0
; Rotations speed
Sphere7AnglesSpeedFlt	dd	-2.1,-1.8,2.0
; Objects datas
Sphere7Color		dd	0.6,0.6,0.6,0.5
Sphere7Radius		dq	0.3
sphere7Parts		dd	16
Sphere7Position		dd	0.0,-1.5,0.0
GlSphere7		dd	0

; --------------- Procedures Declarations
			.code

MainInit		PROTO	:DWORD
MainLoop		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
TopXY			PROTO	:DWORD,:DWORD
DrawScene		PROTO
GlInit			PROTO	:DWORD,:DWORD
ResizeObject		PROTO	:DWORD,:DWORD
CreateSphere		PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
SetLightSource		PROTO	:DWORD,:DWORD,:DWORD
RotateObject		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
DeleteSpheres		PROTO
LoadTExture		PROTO	:DWORD,:DWORD
BitmapFromFile2		PROTO	:DWORD
LoadFile		PROTO	:DWORD,:DWORD

; --------------- Procedures Section
CenterForm		PROC	wDim:DWORD, sDim:DWORD
			shr	sDim,1
			shr	wDim,1
			mov	eax,wDim
			sub	sDim,eax
			mov	eax,sDim
			ret
CenterForm		ENDP

DoEvents		PROC
			LOCAL	msg:MSG
StartLoop:		; Check for waiting messages
			invoke	PeekMessage,ADDR msg,0,0,0,PM_NOREMOVE
			test	eax,eax
			jz	NoMsg
			invoke	GetMessage,ADDR msg,NULL,0,0
			test	eax,eax
			jz	ExitLoop
			invoke	DispatchMessage,ADDR msg
			jmp	StartLoop
NoMsg:			; No pending messages: draw the scene
			invoke	Sleep,1
			invoke	DrawScene
			jmp	StartLoop
ExitLoop:		mov	eax,msg.wParam
			ret
DoEvents		ENDP

; --------------- Open a file and load it into memory
LoadFile		proc	FName:dword,ReadBytes:dword
			local	FHandle:dword
			local	FSize:dword
			local	FPosition:dword
			mov	FPosition,0
			invoke	CreateFile,FName,GENERIC_READ,0,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,0
			inc	eax
			je	Error_LoadFile
			dec	eax
			mov	FHandle,eax
			invoke	GetFileSize,eax,0
			inc	eax
			je	Error_LoadFile
			dec	eax
			mov	FSize,eax
			inc	eax				; Append a 0 char
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			test	eax,eax
			jz	Error_LoadFile
			mov	FPosition,eax
			invoke	ReadFile,FHandle,FPosition,FSize,ReadBytes,0
			invoke	CloseHandle,FHandle
Error_LoadFile:		mov	eax,FPosition			; Return the memory block address
			ret
LoadFile		endp

; --------------- Program start
start:			invoke	GetModuleHandle,NULL
			mov	hInstance, eax
			invoke	MainInit,hInstance
			invoke	ExitProcess,eax

; --------------- Program main inits
MainInit 		PROC	hInst:DWORD
			LOCAL	wc:WNDCLASSEX
			LOCAL	Wwd:DWORD
			LOCAL	Wht:DWORD
			LOCAL	Wtx:DWORD
			LOCAL	Wty:DWORD
			LOCAL	PixFormat:DWORD
			LOCAL	WINRect:RECT
	        	mov	wc.cbSize,sizeof WNDCLASSEX
			mov	wc.style,CS_HREDRAW or CS_VREDRAW
			mov	wc.lpfnWndProc,offset MainLoop
			mov	wc.cbClsExtra,NULL
			mov	wc.cbWndExtra,NULL
			push	hInst
			pop	wc.hInstance
			mov	wc.hbrBackground,NULL
			mov	wc.lpszMenuName,NULL
			mov	wc.lpszClassName,offset szClassName
			invoke	LoadIcon,hInst,2
			mov	wc.hIcon,eax
			invoke	LoadCursor,NULL,IDC_ARROW
			mov	wc.hCursor,eax
			mov	wc.hIconSm,0
			invoke	RegisterClassEx,ADDR wc
			mov	Wwd,400
			mov	Wht,420
			invoke	GetSystemMetrics,SM_CXSCREEN
			invoke	CenterForm,Wwd,eax
			mov	Wtx,eax
			invoke	GetSystemMetrics,SM_CYSCREEN
			invoke	CenterForm,Wht,eax
			mov	Wty,eax
			invoke	CreateWindowEx,0,ADDR szClassName, ADDR szDisplayName,
						WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
						Wtx,Wty,Wwd,Wht, NULL,NULL, hInst,NULL
			mov	hWnd,eax
			invoke	GetDC,hWnd
			mov	MainHDC,eax
			mov	ax,SIZEOF PixFrm
			mov	PixFrm.nSize,ax
			mov	PixFrm.nVersion,1
			mov	PixFrm.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
			mov	PixFrm.dwLayerMask,PFD_MAIN_PLANE
			mov	PixFrm.iPixelType,PFD_TYPE_RGBA
			mov	PixFrm.cColorBits,32
			mov	PixFrm.cDepthBits,32
			mov	PixFrm.cAccumBits,0
			mov	PixFrm.cStencilBits,0
			invoke	ChoosePixelFormat,MainHDC,ADDR PixFrm
			mov	PixFormat,eax
			invoke	SetPixelFormat,MainHDC,PixFormat,ADDR PixFrm
			test	eax,eax
			jz	NoPixelFmt
			invoke	wglCreateContext,MainHDC
			mov	OpenDC,eax
			invoke	wglMakeCurrent,MainHDC,OpenDC
			invoke	GetClientRect,hWnd,ADDR WINRect
			invoke	GlInit,WINRect.right,WINRect.bottom
NoPixelFmt:		invoke	ShowWindow,hWnd,SW_SHOWNORMAL
			invoke	UpdateWindow,hWnd
			call	DoEvents
			ret
MainInit 		ENDP

; --------------- Program main loop
MainLoop		PROC	hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
			LOCAL	WINRect:RECT
			.if	uMsg == WM_SIZE
				invoke	GetClientRect,hWin,ADDR WINRect
				invoke	ResizeObject,WINRect.right,WINRect.bottom
				jmp	FallOut
			.elseif	uMsg == WM_CLOSE
				mov	eax,OpenDC
				test	eax,eax
				jz	NoGlDC
				; Delete our objects
				invoke	DeleteSpheres
				invoke	wglDeleteContext,OpenDC
NoGlDC:				invoke	ReleaseDC,hWin,MainHDC
				invoke	DestroyWindow,hWin
FallOut:			xor	eax,eax
				ret
			.elseif uMsg == WM_DESTROY
				invoke	PostQuitMessage,NULL
				jmp	FallOut
			.endif
			invoke	DefWindowProc,hWin,uMsg,wParam,lParam
			ret
MainLoop		ENDP

; ------------------------------
; OpenGl related stuff
; ------------------------------

; --------------- Init the scene
GlInit			PROC	ParentW:DWORD,ParentH:DWORD
			; Textures on
			invoke	LoadTExture,addr szTextureName,1
			mov	hTexture,eax
			invoke	CreateSphere,1,GLU_FILL,GLU_SMOOTH,ADDR Sphere1Color,ADDR Sphere1Radius,sphere1Parts,hTexture
			mov	GlSphere1,eax
			invoke	CreateSphere,2,GLU_FILL,GLU_SMOOTH,ADDR Sphere2Color,ADDR Sphere2Radius,sphere2Parts,0
			mov	GlSphere2,eax
			invoke	CreateSphere,3,GLU_FILL,GLU_SMOOTH,ADDR Sphere3Color,ADDR Sphere3Radius,sphere3Parts,0
			mov	GlSphere3,eax
			invoke	CreateSphere,4,GLU_FILL,GLU_SMOOTH,ADDR Sphere4Color,ADDR Sphere4Radius,sphere4Parts,0
			mov	GlSphere4,eax
			invoke	CreateSphere,5,GLU_FILL,GLU_SMOOTH,ADDR Sphere5Color,ADDR Sphere5Radius,sphere5Parts,0
			mov	GlSphere5,eax
			invoke	CreateSphere,6,GLU_FILL,GLU_SMOOTH,ADDR Sphere6Color,ADDR Sphere6Radius,sphere6Parts,0
			mov	GlSphere6,eax
			invoke	CreateSphere,7,GLU_FILL,GLU_SMOOTH,ADDR Sphere7Color,ADDR Sphere7Radius,sphere7Parts,0
			mov	GlSphere7,eax
			; Set global flags
			invoke	glEnable,GL_DEPTH_TEST
			invoke	glEnable,GL_LIGHTING
			invoke	glEnable,GL_CULL_FACE
			invoke	glShadeModel,GL_SMOOTH
			invoke	glEnable,GL_NORMALIZE
			invoke	glEnable,GL_BLEND
			invoke	glBlendFunc,GL_ONE,GL_ONE
			invoke	SetLightSource,GL_LIGHT0,ADDR LightSourcePosition,ADDR LightAmbient
			invoke	SetLightSource,GL_LIGHT1,ADDR LightSource2Position,ADDR Light2Ambient
			invoke	SetLightSource,GL_LIGHT2,ADDR LightSource3Position,ADDR Light3Ambient
			ret
GlInit			ENDP

; --------------- Display the scene
DrawScene		PROC
	    		invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
			invoke	glPushMatrix
				invoke	RotateObject,1,ADDR Sphere1Position,ADDR Sphere1AnglesSpeedFlt,ADDR Sphere1AnglesFlt
				invoke	glPushMatrix
					invoke	RotateObject,2,ADDR Sphere2Position,ADDR Sphere2AnglesSpeedFlt,ADDR Sphere2AnglesFlt
				invoke	glPopMatrix
				invoke	glPushMatrix
					invoke	RotateObject,3,ADDR Sphere3Position,ADDR Sphere3AnglesSpeedFlt,ADDR Sphere3AnglesFlt
				invoke	glPopMatrix
				invoke	glPushMatrix
					invoke	RotateObject,4,ADDR Sphere4Position,ADDR Sphere4AnglesSpeedFlt,ADDR Sphere4AnglesFlt
				invoke	glPopMatrix
				invoke	glPushMatrix
					invoke	RotateObject,5,ADDR Sphere5Position,ADDR Sphere5AnglesSpeedFlt,ADDR Sphere5AnglesFlt
				invoke	glPopMatrix
				invoke	glPushMatrix
					invoke	RotateObject,6,ADDR Sphere6Position,ADDR Sphere6AnglesSpeedFlt,ADDR Sphere6AnglesFlt
				invoke	glPopMatrix
				invoke	glPushMatrix
					invoke	RotateObject,7,ADDR Sphere7Position,ADDR Sphere7AnglesSpeedFlt,ADDR Sphere7AnglesFlt
				invoke	glPopMatrix
			invoke	glPopMatrix
			invoke	SwapBuffers,MainHDC
			ret
DrawScene		ENDP

; --------------- Resize the scene
ResizeObject		PROC	ParentW:DWORD,ParentH:DWORD
			invoke	glViewport,0,0,ParentW,ParentH
			invoke	glMatrixMode,GL_PROJECTION
			invoke	glLoadIdentity
			invoke	gluPerspective,DWORD PTR Value45Dbl,DWORD PTR Value45Dbl+4,DWORD PTR Value1Dbl,DWORD PTR Value1Dbl+4,DWORD PTR Value3Dbl,DWORD PTR Value3Dbl+4,DWORD PTR Value7Dbl,DWORD PTR Value7Dbl+4
			invoke	glMatrixMode,GL_MODELVIEW
			invoke	glLoadIdentity
			ret
ResizeObject		ENDP

; --------------- Free the memory allocated for the spheres
DeleteSpheres		PROC
			invoke	gluDeleteQuadric,GlSphere1
			invoke	gluDeleteQuadric,GlSphere2
			invoke	gluDeleteQuadric,GlSphere3
			invoke	gluDeleteQuadric,GlSphere4
			invoke	gluDeleteQuadric,GlSphere5
			invoke	gluDeleteQuadric,GlSphere6
			invoke	gluDeleteQuadric,GlSphere7
			ret
DeleteSpheres		ENDP

; --------------- Create a sphere with glu object
CreateSphere		PROC	ListNumber:DWORD,FillType:DWORD,NormalsType:DWORD,Color:DWORD,Radius:DWORD,Parts:DWORD,SetTexture:DWORD
			LOCAL	GlSphere:DWORD
			invoke	glNewList,ListNumber,GL_COMPILE
			; Create a template
			invoke	gluNewQuadric
			mov	GlSphere,eax
			; Set object draw style
			invoke	gluQuadricDrawStyle,GlSphere,FillType
			; Set normals style
			invoke	gluQuadricNormals,GlSphere,NormalsType
			; Turn texture coords on
			.if SetTexture != 0
				invoke	glEnable,GL_TEXTURE_2D
				invoke	gluQuadricTexture,GlSphere,GL_TRUE
			.else
				invoke	glDisable,GL_TEXTURE_2D
				invoke	gluQuadricTexture,GlSphere,GL_FALSE
			.endif
			; Set object color
			invoke	glMaterialfv,GL_FRONT,GL_DIFFUSE,Color
			mov	eax,Radius
			; Create a sphere primitive
			invoke	gluSphere,GlSphere,[eax],[eax+4],Parts,Parts
			invoke	glEndList
			mov	eax,GlSphere
			ret
CreateSphere		ENDP

; --------------- Set a light source
SetLightSource		PROC	LtNumber:DWORD,LtPosition:DWORD,LtAmbient:DWORD
			invoke	glLightfv,LtNumber,GL_POSITION,LtPosition
			invoke	glLightfv,LtNumber,GL_DIFFUSE,ADDR LightDiffuse
			invoke	glLightfv,LtNumber,GL_CONSTANT_ATTENUATION,ADDR LightConstAtt
			invoke	glLightfv,LtNumber,GL_LINEAR_ATTENUATION,ADDR LightLinAtt
			invoke	glLightfv,LtNumber,GL_QUADRATIC_ATTENUATION,ADDR LightQuadAtt
			invoke	glLightfv,LtNumber,GL_SPOT_CUTOFF,ADDR SpotCut
			invoke	glLightfv,LtNumber,GL_SPOT_EXPONENT,ADDR SpotExp
			invoke	glLightfv,LtNumber,GL_SPOT_DIRECTION,ADDR SpotDir
			invoke	glEnable,LtNumber
			ret	
SetLightSource		ENDP

; --------------- Load and set a texture frm a TGA file
LoadTExture		PROC	TextureFileName:DWORD,TextureNumber:DWORD
			LOCAL	TGABuffer:DWORD
			LOCAL	TextureX:DWORD
			LOCAL	TextureY:DWORD
			LOCAL	TextureBpp:DWORD
			LOCAL	TextureHandle:DWORD
			LOCAL	TextureBuffer:DWORD
			LOCAL	bmInfos:BITMAPINFO
			LOCAL	FSize:DWORD
			
			mov	TextureHandle,0
			; Load texture into memory
			invoke	LoadFile,TextureFileName,addr FSize
			test	eax,eax
			jz	NoTextureLoaded
			mov	TGABuffer,eax
			; Decode the TGA file
			mov	ebx,eax
			movzx	eax,word ptr [ebx+12]
			test	eax,eax
			js	WrongTextureFormat
			jz	WrongTextureFormat
			mov	TextureX,eax
			movzx	eax,word ptr [ebx+14]
			test	eax,eax
			js	WrongTextureFormat
			jz	WrongTextureFormat
			mov	TextureY,eax
			movzx	eax,byte ptr [ebx+16]
			mov	TextureBpp,eax
			cmp	eax,24			; Must be 24 bits
			je	GoodTextureFormat
			cmp	eax,32			; or 32 bits
			je	GoodTextureFormat
			jmp	WrongTextureFormat
GoodTextureFormat:	lea	eax,[ebx+18]		; Image datas
			mov	TextureBuffer,eax

			; Create a new texture
			invoke	glGenTextures,TextureNumber,addr TextureHandle
			invoke	glBindTexture,GL_TEXTURE_2D,TextureHandle
			; Set filtering
			invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
			invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
			mov	eax,TextureBpp
			.if eax == 24
				; Set it as 24 bits texture
				invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,TextureX,TextureY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureBuffer
			.elseif eax == 32
				; Set it as 32 bits texture
				invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGBA,TextureX,TextureY,0,GL_RGBA,GL_UNSIGNED_BYTE,TextureBuffer
			.endif
WrongTextureFormat:	; Free the file
			invoke	GlobalFree,TGABuffer
			; Return texture handle
NoTextureLoaded:	mov	eax,TextureHandle
			ret
LoadTExture		ENDP

; --------------- Position and rotate an object
RotateObject		PROC	ListNumber:DWORD,XYZPosition:DWORD,XYZRotations:DWORD,XYZAngles:DWORD
			LOCAL	LocXSpd:DWORD
			LOCAL	LocYSpd:DWORD
			LOCAL	LocZSpd:DWORD
			LOCAL	LocXAngle:DWORD
			LOCAL	LocYAngle:DWORD
			LOCAL	LocZAngle:DWORD
			mov	eax,XYZPosition
			mov	ecx,[eax]
			mov	ebx,[eax+4]
			mov	eax,[eax+8]
			invoke	glTranslatef,ecx,ebx,eax
	    		mov	eax,XYZAngles			; Rotate X
	    		mov	ebx,XYZRotations
	    		fld	DWORD PTR [eax]
	    		fadd	DWORD PTR [ebx]
	    		fstp	DWORD PTR [eax]
	    		invoke	glRotatef,[eax],Value0Flt,Value1Flt,Value0Flt
	    		mov	eax,XYZAngles			; Rotate Y
	    		mov	ebx,XYZRotations
	    		fld	DWORD PTR [eax+4]
	    		fadd	DWORD PTR [ebx+4]
	    		fstp	DWORD PTR [eax+4]
	    		invoke	glRotatef,[eax+4],Value1Flt,Value0Flt,Value0Flt
	    		mov	eax,XYZAngles			; Rotate Z
	    		mov	ebx,XYZRotations
	    		fld	DWORD PTR [eax+8]
	    		fadd	DWORD PTR [ebx+8]
	    		fstp	DWORD PTR [eax+8]
	    		invoke	glRotatef,DWORD PTR [eax+8],Value0Flt,Value0Flt,Value1Flt
			invoke	glCallList,ListNumber
			ret
RotateObject		ENDP

; --------------- Program end
end start
